// Generated by CoffeeScript 2.3.1
var _, objprint;

objprint = require('.');

_ = require('lodash');

exports.simple = function(test) {
  var actualAr, actualstr, i, j, k, len, len1, obj, options, str, testAr, teststr;
  obj = [
    {
      "First Name": 'John',
      "Last Name": 'Smith',
      alive: true,
      "net.worth": 1199,
      age: 22,
      How_Many_Cats_Owned: 2,
      zip: '00000',
      dob: new Date('Tue Apr 2 1946 20:41:37 GMT-0400 (EDT)')
    },
    {
      "First Name": 'Buckaroo',
      "Last Name": 'Banzai',
      alive: false,
      age: 4319,
      "net.worth": 100000222.44,
      How_Many_Cats_Owned: 1,
      zip: '12345',
      dob: new Date('Tue Dec 25 1957 20:41:37 GMT-0400 (EDT)')
    }
  ];
  options = {
    longdateformat: true,
    // using the "numeral" NPM package. See that documentation for formatting details
    numberformat: {
      "net.worth": '$ 0,0.00',
      age: '0,0'
    }
  };
  teststr = "\n┌────────────┬───────────┬───────┬──────────────────┬───────┬───────┬───────┬──────────────────────┐\n│            │           │       │                  │       │  How  │       │                      │\n│            │           │       │                  │       │ Many  │       │                      │\n│            │           │       │       net        │       │ Cats  │       │                      │\n│ First Name │ Last Name │ alive │      worth       │  age  │ Owned │  zip  │         dob          │\n├────────────┼───────────┼───────┼──────────────────┼───────┼───────┼───────┼──────────────────────┤\n│ John       │ Smith     │ true  │       $ 1,199.00 │    22 │     2 │ 00000 │ 04/02/1946  08:41 pm │\n│ Buckaroo   │ Banzai    │ false │ $ 100,000,222.44 │ 4,319 │     1 │ 12345 │ 12/25/1957  07:41 pm │\n└────────────┴───────────┴───────┴──────────────────┴───────┴───────┴───────┴──────────────────────┘\n  (2 rows returned)\n";
  actualstr = objprint.format(obj, options);
  actualAr = actualstr.split('\n');
  testAr = teststr.split('\n');
  for (i = j = 0, len = actualAr.length; j < len; i = ++j) {
    str = actualAr[i];
    // test trimmed strings
    test.equal(_.trim(testAr[i]), _.trim(actualAr[i]));
  }
  console.log(actualstr);
  // test.equal teststr, actualstr
  teststr = "\n┌────────────┬───────────┬───────┬──────────────────┬───────┬───────┬───────┬──────────────────────┐\n                                                               How\n                                                              Many\n                                         net                  Cats\n  First Name   Last Name   alive        worth          age    Owned    zip            dob\n├────────────┼───────────┼───────┼──────────────────┼───────┼───────┼───────┼──────────────────────┤\n  John         Smith       true          $ 1,199.00      22       2   00000   04/02/1946  08:41 pm\n  Buckaroo     Banzai      false   $ 100,000,222.44   4,319       1   12345   12/25/1957  07:41 pm\n└────────────┴───────────┴───────┴──────────────────┴───────┴───────┴───────┴──────────────────────┘\n  (2 rows returned)\n";
  options = {
    longdateformat: true,
    spaceDivider: true,
    // using the "numeral" NPM package. See that documentation for formatting details
    numberformat: {
      "net.worth": '$ 0,0.00',
      age: '0,0'
    }
  };
  actualstr = objprint.format(obj, options);
  actualAr = actualstr.split('\n');
  testAr = teststr.split('\n');
  for (i = k = 0, len1 = actualAr.length; k < len1; i = ++k) {
    str = actualAr[i];
    // test trimmed strings
    test.equal(_.trim(testAr[i]), _.trim(actualAr[i]));
  }
  console.log(actualstr);
  return test.done();
};

exports.parseTable = function(test) {
  var ar, expectedAr, tableText;
  tableText = "# this is a comment\n# ignores blank lines, and blank table rows\n\n|------|-----------|------|\n| col1 | strHeader | col3 |\n|------|-----------|------|\n|    1 | hello     |   22 |\n|    2 | world     |    4 |\n|      |           |      |\n|------|-----------|------|";
  expectedAr = [
    {
      col1: '1',
      strHeader: 'hello',
      col3: '22'
    },
    {
      col1: '2',
      strHeader: 'world',
      col3: '4'
    }
  ];
  ar = objprint.parse(tableText);
  test.deepEqual(ar, expectedAr);
  return test.done();
};

exports.multiLine = function(test) {
  var actualAr, actualstr, i, j, len, obj, options, str, testAr, teststr;
  obj = [
    {
      "First Name": 'George',
      "Last Name": 'Washington',
      age: 67,
      alive: false,
      description: "George Washington was an American political leader, military general, statesman, and Founding Father,\nwho also served as the first President of the United States from 1789 to 1797.\nWashington commanded Patriot forces in the new nation's vital American Revolutionary War,\nand led them to victory over the British."
    },
    {
      "First Name": 'Buckaroo',
      "Last Name": 'Banzai',
      alive: false,
      age: 4319,
      description: "Buckaroo Banzai is caught with his trusted allies, the Hong Kong Cavaliers,\nin a battle to the death between evil red aliens and good black aliens from Planet 10.\nLed by demonic dictator John Whorfin, who has taken over the body of Italian scientist Dr. Emilio Lizardo,\nthe aliens try to get the Overthruster back from Buckaroo Banzai."
    }
  ];
  teststr = "\n┌────────────┬────────────┬──────┬───────┬──────────────────────────────────────────────────────────────┐\n│ First Name │ Last Name  │ age  │ alive │                         description                          │\n├────────────┼────────────┼──────┼───────┼──────────────────────────────────────────────────────────────┤\n│ George     │ Washington │   67 │ false │ George Washington was an American political leader, military │\n│            │            │      │       │ ↪   general, statesman, and Founding Father,                 │\n│            │            │      │       │ who also served as the first President of the United States  │\n│            │            │      │       │ ↪  from 1789 to 1797.                                        │\n│            │            │      │       │ Washington commanded Patriot forces in the new nation's vita │\n│            │            │      │       │ ↪  l American Revolutionary War,                             │\n│            │            │      │       │ and led them to victory over the British.                    │\n│ Buckaroo   │ Banzai     │ 4319 │ false │ Buckaroo Banzai is caught with his trusted allies, the Hong  │\n│            │            │      │       │ ↪  Kong Cavaliers,                                           │\n│            │            │      │       │ in a battle to the death between evil red aliens and good bl │\n│            │            │      │       │ ↪  ack aliens from Planet 10.                                │\n│            │            │      │       │ Led by demonic dictator John Whorfin, who has taken over the │\n│            │            │      │       │ ↪   body of Italian scientist Dr. Emilio Lizardo,            │\n│            │            │      │       │ the aliens try to get the Overthruster back from Buckaroo Ba │\n│            │            │      │       │ ↪  nzai.                                                     │\n└────────────┴────────────┴──────┴───────┴──────────────────────────────────────────────────────────────┘\n  (2 rows returned)\n";
  options = {
    colMaxlen: 60
  };
  actualstr = objprint.format(obj, options);
  actualAr = actualstr.split('\n');
  testAr = teststr.split('\n');
  for (i = j = 0, len = actualAr.length; j < len; i = ++j) {
    str = actualAr[i];
    // test trimmed strings
    test.equal(_.trim(testAr[i]), _.trim(actualAr[i]));
  }
  console.log(actualstr);
  return test.done();
};
